import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.lang.*;
import java.io.*;
import java.net.*;
import java.nio.charset.*;
import java.nio.file.*;
import java.util.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import javax.swing.filechooser.*;
import javax.swing.text.*;

//-------------------------------------
public class Usage extends JFrame implements WindowListener {

static Usage  mf;

JButton     sbar;
JScrollPane spta;
JTextArea   txta;

Font   taf, uif;
int    maxx, maxy, winx, winy;
int    tafs, uifs, wxp, wyp;
String dsps, stxt, tafn, uifn, wdir;

static final int  UIFSIZ = 40;
static final int  TAFSIZ = 20;
static final String UIFNLIT = "UIFN";
static final String UIFSLIT = "UIFS";
static final String TAFNLIT = "TAFN";
static final String TAFSLIT = "TAFS";
static final String WXPLIT = "WXP";
static final String WYPLIT = "WYP";

//-------------------------------------
class ADirectory implements ActionListener {
public void actionPerformed(ActionEvent fae) {
  GetDirectory();
}}

//-------------------------------------
class AMinimize implements ActionListener {
public void actionPerformed(ActionEvent qae) {
  mf.setState(Frame.ICONIFIED);
}}

//-------------------------------------
class AQuit implements ActionListener {
public void actionPerformed(ActionEvent qae) {
  System.exit(0);
}}

//-------------------------------------
public void Append(String s) {
  txta.append(s);
}

//-------------------------------------
class CBButton implements ActionListener {
public void actionPerformed(ActionEvent cbae) {
  PopupMain();
}}

//-------------------------------------
class CBKey extends KeyAdapter {
public void keyPressed(KeyEvent ke) {
int   kc;
  kc = ke.getKeyCode();
  if (kc == KeyEvent.VK_F1) PopupMain();
}}

//-------------------------------------
class CBResize extends ComponentAdapter {
public void componentResized(ComponentEvent ce) {
Insets  is;
int     sbh;
  sbh = sbar.getHeight();
  winx = getWidth();
  winy = getHeight();
  is = mf.getInsets();
  winx = winx-is.left-is.right;
  winy = winy-sbh-is.top-is.bottom;
}}

//-------------------------------------
void GetDirectory() {
File          wfil;
FindSize      fs;
int           fsts;
JFileChooser  fc;
  fc = new JFileChooser();
  fc.setPreferredSize(new Dimension((maxx*80)/100, (maxy*90)/100));
  fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
  if (wdir.length() > 0) {
    wfil = new File(wdir);
    fc.setCurrentDirectory(wfil);
  }
  fsts = fc.showOpenDialog(mf);
  if (fsts == JFileChooser.APPROVE_OPTION) {
    wfil = fc.getSelectedFile();
    wdir = wfil.getPath();
    sbar.setText(wdir);
    txta.setText("");
    fs = new FindSize(mf, wdir);
    fs.start();
  }
}

//-------------------------------------
public void Initlz() {
  InitlzVars();
  ReadIniFile();
  InitlzUI();
  LayoutUI();
}

//-------------------------------------
void InitlzUI() {
Image       iimg;
Toolkit     tk;
URL         iurl;
  winx = (maxx*wxp)/100;
  winy = (maxy*wyp)/100;
  uif = new Font(Font.SERIF, Font.BOLD, uifs);
  taf = new Font(Font.MONOSPACED, Font.BOLD, tafs);
  tk = Toolkit.getDefaultToolkit();
  iurl = mf.getClass().getResource("/Usage.png");
  iimg = tk.createImage(iurl);
  setIconImage(iimg);
  sbar = new JButton(stxt);
  sbar.setFont(uif);
  sbar.addActionListener(new CBButton());
  sbar.addKeyListener(new CBKey());
  txta = new JTextArea();
  txta.addKeyListener(new CBKey());
  txta.setFont(taf);
  txta.setBackground(new Color(0xFFFFFF));
  txta.setLineWrap(true);
  spta = new JScrollPane(txta);
  spta.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
  spta.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
}

//-------------------------------------
void InitlzVars() {
  uifs = UIFSIZ;
  tafs = TAFSIZ;
  wxp = 50;
  wyp = 90;
  wdir ="";
  stxt = "Click Here";
}

//-------------------------------------
void LayoutUI() {
  addWindowListener(this);
  mf.addKeyListener(new CBKey());
  mf.addComponentListener(new CBResize());
  mf.setLocation((maxx-winx)/2, (maxy-winy)/2);
  mf.setSize(winx, winy);
  mf.getContentPane().add(sbar, BorderLayout.NORTH);
  mf.getContentPane().add(spta, BorderLayout.CENTER);
  mf.setTitle("Usage");
  mf.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
  mf.setVisible(true);
}

//-------------------------------------
public static void main(String[] args) {
  mf = new Usage();
  mf.Initlz();
}

//-------------------------------------
void PopupMain() {
JMenuItem     mi;
JPopupMenu    pum;
  pum = new JPopupMenu();
  mi = new JMenuItem("Directory");
  mi.setMnemonic('D');
  mi.addActionListener(new ADirectory());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Minimize");
  mi.setMnemonic('M');
  mi.addActionListener(new AMinimize());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Quit");
  mi.setMnemonic('Q');
  mi.addActionListener(new AQuit());
  mi.setFont(uif);
  pum.add(mi);
  pum.show(mf, 0, 0);
}

//-------------------------------------
void ReadIniFile() {
BufferedReader  br;
Charset         cs;
File            inif;
Path            ifp;
String          jini, line, nam, val;
String[]        sa;
  jini = System.getenv("JINI")+"bella.ini";
  inif = new File(jini);
  if (!inif.exists()) {
    stxt = "no ini file";
    return;
  }
  ifp = inif.toPath();
  cs = Charset.forName("US-ASCII");
  try {
    br = Files.newBufferedReader(ifp, cs);
    while ((line = br.readLine()) != null) {
      sa = line.split("=");
      if (sa.length==2) {
        nam = sa[0];
        val = sa[1];
        if (nam.compareTo(UIFNLIT)==0) uifn = val;
        if (nam.compareTo(UIFSLIT)==0) uifs = Integer.parseInt(val);
        if (nam.compareTo(TAFNLIT)==0) tafn = val;
        if (nam.compareTo(TAFSLIT)==0) tafs = Integer.parseInt(val);
        if (nam.compareTo(WXPLIT)==0) wxp = Integer.parseInt(val);
        if (nam.compareTo(WYPLIT)==0) wyp = Integer.parseInt(val);
      }
    }
  } catch (IOException x) { System.err.format("IOException: %s%n", x); }
}

//-------------------------------------
public Usage() {
Dimension dim;
Toolkit   tk;
  tk = Toolkit.getDefaultToolkit();
  dim = tk.getScreenSize();
  maxx = dim.width;
  maxy = dim.height;
}

//-------------------------------------
public void windowActivated(WindowEvent e) {}
public void windowDeactivated(WindowEvent e) {}
public void windowDeiconified(WindowEvent e) {}
public void windowIconified(WindowEvent e) {}
public void windowClosing(WindowEvent e) {}
public void windowClosed(WindowEvent e) {}
public void windowOpened(WindowEvent e) {}


//-------------------------------------
}
